/**********************************************************
 * dirnode.c -- member functions of class _DI_Node        *
 * Jun Yang, November 17, 1994				  *
 **********************************************************/

/*--------------- Header Files ---------------*/

#include "swan.h"
#include "laydir.h"

// Functions

_DI_Node::_DI_Node(_DI_NODEID node_id)
{
	id = node_id ;
	nblist = new _DI_NBLIST ;
	nblist_in = new _DI_NBLIST ;
	lambda = 0 ;
	layer = 0 ;
	order = 0 ;
	dummy = FALSE ;
	visited = FALSE ;
	x = y = 0 ;
	width = height = 0 ;
}

_DI_Node::~_DI_Node(void)
{
	delete nblist ;
	delete nblist_in ;
}

BasicNode* _DI_Node::getID(void) 
{
	return id ;
}

_DI_NBLIST* _DI_Node::getNBList(void) 
{
	return nblist ;
}

_DI_NBLIST* _DI_Node::getNBList_in(void) 
{
	return nblist_in ;
}

int _DI_Node::getLambda(void) 
{
	return lambda ;
}

bool _DI_Node::setLambda(int t_lambda) 
{
	lambda = t_lambda ;
	return TRUE ;
}

int _DI_Node::getLayer(void) 
{
	return layer ;
}

bool _DI_Node::setLayer(int t_layer) 
{
	layer = t_layer ;
	return TRUE ;
}

bool _DI_Node::isDummy(void) 
{
	return dummy ;
}

void _DI_Node::setDummy(bool t_dummy) 
{
	dummy = t_dummy ;
}

bool _DI_Node::isVisited(void) 
{
	return visited ;
}

void _DI_Node::markVisited(bool t_visited) 
{
	visited = t_visited ;
}

int _DI_Node::getX(void) 
{
	return x ;
}

void _DI_Node::setX(int t_x)
{
	x = t_x ;
}

int _DI_Node::getY(void)
{
	return y ;
}

void _DI_Node::setY(int t_y)
{
	y = t_y ;
}

int _DI_Node::getWidth(void)
{
	return width ;
}

void _DI_Node::setWidth(int t_width) 
{
	width = t_width ;
}

int _DI_Node::getHeight(void) 
{
	return height ;
}

void _DI_Node::setHeight(int t_height) 
{
	height = t_height ;
}

_DI_nbnode* _DI_Node::searchNB_in(_DI_Node* nbnode)
{
	bool		ok ;
	_DI_nbnode	*temp_nb ;
	
	ok = (*nblist_in).getFirstNode(temp_nb) ;
	while (ok) {
	    if (temp_nb->id == nbnode)
		return temp_nb ;
            ok = (*nblist_in).getNextNode(temp_nb) ;
	}
	return NULL ;
}

/**********************************************************
 * End of dirnode.c   				          *
 **********************************************************/
